﻿// 根据class获取DOM元素
function getElementsByClass(node, searchClass, tag) {
	var classElements = new Array();
	var els = node.getElementsByTagName(tag);
	var elsLen = els.length;
	var pattern = new RegExp("\\b" + searchClass + "\\b");
	for (i = 0, j = 0; i < elsLen; i++) {
		if (pattern.test(els[i].className)) {
			classElements[j] = els[i];
			j++;
		}
	}
	return classElements;
}

//在路径中获取文件名
function getFileName(str) {
	var pos = str.lastIndexOf("/") * 1;
	return str.substring(pos + 1);
}

//控制文件处理显示
function FileProgress(file, targetID, deleteImageUrl) {
	this.fileProgressID = file.id;

	this.opacity = 100;
	this.height = 0;

	this.fileProgressWrapper = document.getElementById(this.fileProgressID);

	// 创建上传信息显示区域
	if (!this.fileProgressWrapper) {
		// 上传图片容器
		this.fileProgressWrapper = document.createElement("div");
		this.fileProgressWrapper.className = "progressWrapper";
		this.fileProgressWrapper.id = this.fileProgressID;

		// 上方容器
		this.fileProgressElement = document.createElement("div");
		this.fileProgressElement.className = "progressContainer";

		// 上传进度
		var progressBar = document.createElement("div");
		progressBar.className = "progressBarInProgress";

		// 上传的图片
		var uploadImage = document.createElement("img");
		uploadImage.className = "thubPhoto";
		uploadImage.style.visibility = "hidden";
		uploadImage.style.border = "0";

		// 下方状态栏
		this.progressBarStatus = document.createElement("div");
		this.progressBarStatus.className = "progressBarStatus";

		// 状态文本
		var progressStatus = document.createElement("div");
		progressStatus.className = "progressStatus";
		progressStatus.innerHTML = "&nbsp;";

		// 删除按钮容器
		var progressCancel = document.createElement("div");
		progressCancel.className = "progressCancel";
		progressCancel.style.display = "none";

		// 删除按钮
		var cancelImage = document.createElement("img");
		cancelImage.src = deleteImageUrl;
		cancelImage.style.border = "0";

		progressCancel.appendChild(cancelImage);

		this.progressBarStatus.appendChild(progressStatus);
		this.progressBarStatus.appendChild(progressCancel);

		this.fileProgressElement.appendChild(progressBar);
		this.fileProgressElement.appendChild(uploadImage);

		this.fileProgressWrapper.appendChild(this.fileProgressElement);
		this.fileProgressWrapper.appendChild(this.progressBarStatus);

		document.getElementById(targetID).appendChild(this.fileProgressWrapper);
	} else {
		this.fileProgressElement = this.fileProgressWrapper.firstChild;
		this.progressBarStatus = this.fileProgressWrapper.childNodes[1];
	}

	this.height = this.fileProgressWrapper.offsetHeight;

}
// 上传进度显示
FileProgress.prototype.setProgress = function (percentage) {
	this.fileProgressElement.className = "progressContainer green";
	this.fileProgressElement.childNodes[0].className = "progressBarInProgress";
	this.fileProgressElement.childNodes[0].style.width = percentage + "%";
};
// 上传完成
FileProgress.prototype.setComplete = function () {
	this.fileProgressElement.className = "progressContainer blue";
	this.fileProgressElement.childNodes[0].className = "progressBarComplete";
	this.fileProgressElement.childNodes[0].style.width = "";
};
// 上传发生错误，上传区域在5秒后自动消失
FileProgress.prototype.setError = function () {
	this.fileProgressElement.className = "progressContainer red";
	this.fileProgressElement.childNodes[0].className = "progressBarError";
	this.fileProgressElement.childNodes[0].style.width = "";

	var oSelf = this;
	setTimeout(function () {
		oSelf.disappear();
	}, 5000);
};
// 显示上传图片的缩略图
FileProgress.prototype.setUploadPhoto = function (url) {
	this.fileProgressElement.childNodes[0].style.display = "none";
	this.fileProgressElement.childNodes[1].style.visibility = "visible";
	this.fileProgressElement.childNodes[1].src = url;
};
// 显示删除效果
FileProgress.prototype.setCancelled = function () {
	this.fileProgressElement.className = "progressContainer";
	this.fileProgressElement.childNodes[0].className = "progressBarError";
	this.fileProgressElement.childNodes[0].style.width = "";

	var oSelf = this;
	setTimeout(function () {
		oSelf.disappear();
	}, 1000);
};
// 缩略图位置显示处理状态：一般用来设置上传错误状态
FileProgress.prototype.setStatus = function (status) {
	this.fileProgressElement.innerHTML = status;
};

// 缩略图下方显示处理状态：上传成功、正在删除等
FileProgress.prototype.setUploadStatus = function (status) {
	this.progressBarStatus.childNodes[0].innerHTML = status;
};

// 隐藏或显示删除按钮
FileProgress.prototype.toggleCancel = function (show, swfUploadInstance) {
	this.progressBarStatus.childNodes[1].style.display = show ? "" : "none";
	if (swfUploadInstance) {
		var fileID = this.fileProgressID;
		var oSelf = this;
		var progressElement = this.fileProgressElement;
		var basePath = swfUploadInstance.customSettings.basePath;

		//为按钮绑定删除事件
		this.progressBarStatus.childNodes[1].childNodes[0].onclick = function () {
			swfUploadInstance.cancelUpload(fileID);

			// 获取图片名称
			var thubPhoto = getElementsByClass(progressElement, "thubPhoto", "img");
			if (thubPhoto.length > 0) {
				oSelf.setUploadStatus("正在删除");
				
				var filename = getFileName(thubPhoto[0].src);
				
				// 去服务器删除文件
				deleteFile(filename,swfUploadInstance);

				// 要删除文件的后缀名
				var del_file_ext = filename.substr(filename.indexOf('.') + 1).toLowerCase();

				// 从隐藏域删除保存的文件名
				if(swfUploadInstance.customSettings.upload_files_save_elementid!=null &&
				swfUploadInstance.customSettings.upload_files_save_elementid!=undefined){
					var up_files = document.getElementById(swfUploadInstance.customSettings.upload_files_save_elementid).value;
					var up_files_arr = up_files.split(";");
					
					var new_up_files = "";
					for (var i in up_files_arr) {
						if (GetFileNameByPath(up_files_arr[i]) != filename.replace('_thub', '')) {
							new_up_files += up_files_arr[i] + ";";
						}
					}

					document.getElementById(swfUploadInstance.customSettings.upload_files_save_elementid).value = new_up_files;
				}
				
				if(swfUploadInstance.customSettings.upload_thubfiles_save_elementid!=null &&
				swfUploadInstance.customSettings.upload_thubfiles_save_elementid!=undefined){
					var up_thub_files = document.getElementById(swfUploadInstance.customSettings.upload_thubfiles_save_elementid).value;
					var up_thub_files_arr = up_thub_files.split(";");

					var new_up_thub_files = "";
					for (var i in up_thub_files_arr) {
						if (GetFileNameByPath(up_thub_files_arr[i]) != filename) {
							new_up_thub_files += up_thub_files_arr[i] + ";";
						}
					}

					document.getElementById(swfUploadInstance.customSettings.upload_thubfiles_save_elementid).value = new_up_thub_files;
				}

				swfUploadInstance.minusNum();
			}

			setTimeout(function () {
				oSelf.disappear();
			}, 1000);

			return false;
		};
	}
};

function GetFileNameByPath(path) {
	var pos = path.lastIndexOf("/") * 1;
	return path.substring(pos + 1);
}

// 每个上传图片消失的动画
FileProgress.prototype.disappear = function () {

	var reduceOpacityBy = 15;
	var reduceHeightBy = 4;
	var rate = 30; // 15 fps

	if (this.opacity > 0) {
		this.opacity -= reduceOpacityBy;
		if (this.opacity < 0) {
			this.opacity = 0;
		}

		if (this.fileProgressWrapper.filters) {
			try {
				this.fileProgressWrapper.filters.item("DXImageTransform.Microsoft.Alpha").opacity = this.opacity;
			} catch (e) {
				this.fileProgressWrapper.style.filter = "progid:DXImageTransform.Microsoft.Alpha(opacity=" + this.opacity + ")";
			}
		} else {
			this.fileProgressWrapper.style.opacity = this.opacity / 100;
		}
	}

	if (this.height > 0) {
		this.height -= reduceHeightBy;
		if (this.height < 0) {
			this.height = 0;
		}

		this.fileProgressWrapper.style.height = this.height + "px";
	}

	if (this.height > 0 || this.opacity > 0) {
		var oSelf = this;
		setTimeout(function () {
			oSelf.disappear();
		}, rate);
	} else {
		this.fileProgressWrapper.style.display = "none";
	}
};
